package com.walletconnect.dapp.ui.selected_account

import android.view.LayoutInflater
import android.view.ViewGroup
import androidx.recyclerview.widget.DiffUtil
import androidx.recyclerview.widget.ListAdapter
import androidx.recyclerview.widget.RecyclerView
import com.walletconnect.dapp.databinding.ListItemMethodsBinding

class SelectedAccountAdapter(private val onMethodClicked: (String) -> Unit) : ListAdapter<String, SelectedAccountAdapter.ViewHolder>(DIFF_UTIL) {

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ViewHolder {
        return ViewHolder(
            ListItemMethodsBinding.inflate(LayoutInflater.from(parent.context), parent, false)
        )
    }

    override fun onBindViewHolder(holder: ViewHolder, position: Int) {
        holder.binding.mbMethodButton.text = getItem(position)
        holder.binding.mbMethodButton.setOnClickListener {
            onMethodClicked(getItem(position))
        }
    }

    class ViewHolder(val binding: ListItemMethodsBinding) : RecyclerView.ViewHolder(binding.root)

    private companion object {
        val DIFF_UTIL = object : DiffUtil.ItemCallback<String>() {
            override fun areItemsTheSame(oldItem: String, newItem: String): Boolean = oldItem == newItem

            override fun areContentsTheSame(oldItem: String, newItem: String): Boolean = oldItem == newItem
        }
    }
}